<?php
// Sécurité
define('OK',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

// Comptes en attente de validation de l'équipe pédagogique :
// * en début de mdp (donc 41 caractères)
// Comptes en attente de réponse de l'utilisateur :
// ? en début de mdp (non défini, donc 1 caractère)
// Comptes désactivés :
// ! en début de mdp (donc 41 caractères)
// Comptes actifs :
// mdp valant un sha1 (donc "mdp > '0'" dans les where)

//////////////////
// Autorisation //
//////////////////

// Accès aux administrateurs, profs, et lycée. Redirection pour les autres.
// (mais édition possible uniquement pour les comptes administrateurs)
if ( $autorisation && ( $autorisation < 4 ) && !$_SESSION['admin'] )  {
  header("Location: https://$domaine$chemin");
  exit();
}
$mysqli = connectsql();
// Si non connecté, demande de connexion
// Si connexion light : on doit répéter son mot de passe pour aller plus loin
// login.php contient fin()
if ( !$autorisation || $_SESSION['light'] )  {
  $titre = 'Modification des associations utilisateurs-matières';
  $actuel = 'utilisateurs-matieres';
  include('login.php');
}

// Valeur par défaut de la recherche
$requete = 'WHERE XXX';

// Types de comptes
// Pour chaque type : nom complet singulier , clé, nom complet du type, requete sql 
$autorisations = array(
  5=>array('Professeur',  'profs',      'Professeurs',            'autorisation%10 = 5'),
  4=>array('Lycée',       'lycee',      'Lycée',                  'autorisation%10 = 4'),
  3=>array('Colleur',     'colleurs',   'Colleurs',               'autorisation%10 = 3'),    
  2=>array('Élève',       'eleves',     'Élèves'                 ,'autorisation%10 = 2') );
$select_types = '';
foreach ( $autorisations as $v => $a )  {
  $select_types .= "      <option value=\"${a[1]}\">${a[0]}</option>\n";
  if ( isset($_REQUEST['type']) && ( $a[1] == $_REQUEST['type'] ) )  {
    $cle_type = $a[1];
    $requete = "WHERE autorisation%10 = $v AND XXX";
  }
}

// Récupération des matières
$resultat = $mysqli->query('SELECT id, nom, cle FROM matieres ORDER BY ordre');
$matieres = array();
$select_matieres = $th_matieres = $iconesmultiples = '';
while ( $r = $resultat->fetch_assoc() )  {
  $matieres[$r['id']] = 0;
  $select_matieres .= "      <option value=\"${r['cle']}\">${r['nom']}</option>\n";
  $th_matieres .= "          <th class=\"vertical\"><span id=\"m${r['id']}\">${r['nom']}</span></th>\n";
  $iconesmultiples .= "\n          <th class=\"icone\"><span class=\"icon-ok\" data-id=\"${r['id']}\"></span></th>";
  if ( isset($_REQUEST['matiere']) && ( $r['cle'] == $_REQUEST['matiere'] ) )  {
    $cle_matiere = $r['cle'];
    $requete = "JOIN matieres AS m ON FIND_IN_SET(m.id,u.matieres) $requete AND m.id = ${r['id']}";
  }
}
$resultat->free();
$iconesmultiples .= "\n          <th class=\"icone\"><span class=\"icon-cocher\"></span></th>";
//$th_matieres .= "\n        </tr>\n";

// Nombre de colonnes du tableau
$nc = count($matieres)+2;

//////////////
//// HTML ////
//////////////
debut($mysqli,'Modification des associations utilisateurs-matières',$message,$autorisation,'utilisateurs-matieres');
?>

  <div id="icones">
    <a class="icon-aide" title="Aide pour les modifications des associations utilisateurs-matières"></a>
  </div>

  <p id="recherche" class="topbarre">
    <select id="type" onchange="window.location='?type='+this.value+'&amp;matiere='+$(this).next().val();">
      <option value="tout">Filtrer par type</option>
<?php echo( isset($cle_type) ? str_replace("\"$cle_type\"","\"$cle_type\" selected",$select_types) : $select_types ); ?>
    </select>
    <select id="matiere" onchange="window.location='?type='+$(this).prev().val()+'&amp;matiere='+this.value;">
      <option value="tout">Filtrer par matière</option>
<?php echo( isset($cle_matiere) ? str_replace("\"$cle_matiere\"","\"$cle_matiere\" selected",$select_matieres) : $select_matieres ); ?>
    </select>
  </p>

  <article>
    <h3>Liste des utilisateurs</h3>
    <table id="umats" class="utilisateurs" style="display: none;">
      <thead>
        <tr>
          <th></th>
<?php echo $th_matieres; ?>
        </tr>
      </thead>
      <tbody>
<?php
// Recherche des couples (utilisateurs, matières) à ne pas modifier : colles ou transferts utilisés
$matieresbloquees = array();
$resultat = $mysqli->query('SELECT utilisateur, GROUP_CONCAT(matiere) AS matieres FROM (
                              SELECT DISTINCT utilisateur, matiere FROM transferts JOIN transdocs ON transdocs.transfert = transferts.id
                              UNION SELECT DISTINCT eleve, matiere FROM transferts JOIN transdocs ON transdocs.transfert = transferts.id
                              UNION SELECT DISTINCT colleur, matiere FROM heurescolles
                              UNION SELECT DISTINCT eleve, matiere FROM notescolles ) AS t GROUP BY utilisateur');
if ( $resultat->num_rows )
  while ( $r = $resultat->fetch_row() )
    $matieresbloquees[$r[0]] = ",${r[1]},";

// Requête générale
$requete = "SELECT u.id, IF(LENGTH(u.nom),CONCAT(u.nom,' ',prenom),CONCAT('<em>',login,'</em>')) AS nomprenom,
            autorisation%10 AS autorisation, autorisation>10 AS admin, matieres
            FROM utilisateurs AS u $requete ORDER BY nomprenom";

// Fonction de remplissage des lignes
// $qualificatif est le type en toutes lettres pour les comptes non validés ou désactivés
// $autorisation est le type (numérique) affiché, pour les comptes valides
function ligne($r,$matieres,$matieresbloquees,$qualificatif,$autorisation = 0)  {
  if ( ( $autorisation == 3 ) && ( $r['autorisation'] == 5 ) )  {
    $qualificatif = 'Professeur';
    $r['id'] = "c${r['id']}";
  }
  if ( $r['admin'] )
    $qualificatif .= ( strlen($qualificatif) ? ', ' : '' ).'Administrateur';
  if ( strlen($qualificatif) )
    $r['nomprenom'] .= " ($qualificatif)";
  echo "        <tr data-id=\"${r['id']}\">\n          <td>${r['nomprenom']}</td>\n          ";
  foreach ( array_filter(explode(',',$r['matieres'])) as $mid )  {
    // 1 : utilisateur "normal" ; 2 : association bloquée ; 3 : prof, colleur dans cette matière ; 4 : colleur, prof dans cette matière
    if ( $mid[0] == 'c' )
      $matieres[substr($mid,1)] = 1 + 2*( $autorisation == 5);
    else
      $matieres[$mid] = 1 + 3*( $r['id'][0] == 'c' );
  }
  foreach ( $matieres as $mid => $ok )  {
    if ( ( $ok == 1 ) && ( strpos($matieresbloquees,",$mid,") !== false ) )
      $ok = 2;
    echo "<td class=\"icone\">$mid|$ok</td>";
  }
  echo "<td class=\"icone\"><input type=\"checkbox\"></td>\n        </tr>\n";
}

// Récupération des demandes à valider
$resultat = $mysqli->query(str_replace('XXX','mdp LIKE \'*%\'',$requete));
if ( $n = $resultat->num_rows )  {
  echo "        <tr class=\"categorie\">\n          <th>Demandes en attente de validation ($n)</th>$iconesmultiples\n        </tr>\n";
  while ( $r = $resultat->fetch_assoc() )
    ligne($r,$matieres,$matieresbloquees[$r['id']] ?? '',$autorisations[$r['autorisation']][0]);
  $resultat->free();
}

// Récupération des invitations non répondues
$resultat = $mysqli->query(str_replace('XXX','mdp = \'?\'',$requete));
if ( $n = $resultat->num_rows )  {
  echo "        <tr class=\"categorie\">\n          <th>Invitations envoyées en attente de réponse ($n)</th>$iconesmultiples\n        </tr>\n";
  while ( $r = $resultat->fetch_assoc() )
    ligne($r,$matieres,$matieresbloquees[$r['id']] ?? '',$autorisations[$r['autorisation']][0]);
  $resultat->free();
}

// Décompte total des utilisateurs (comptes validés et non désactivés) en fonction de leur type
foreach ( $autorisations as $v => $auto)  {
  $resultat = $mysqli->query(str_replace('XXX',"mdp > '0' AND ( autorisation%10=$v ".( $v == 3 ? 'OR LOCATE(\'c\',matieres) )' : ')' ),$requete));
  if ( $n = $resultat->num_rows )  {
    $ajout = ( $v == 3 ) ? ' <span id="ajoutprof">Ajouter un professeur aux colleurs</span>' : '';
    echo "        <tr class=\"categorie\">\n          <th>{$auto[2]} ($n)$ajout</th>$iconesmultiples\n        </tr>\n";
    while ( $r = $resultat->fetch_assoc() )
      ligne($r,$matieres,$matieresbloquees[$r['id']] ?? '','',$v);
    $resultat->free();
  }
}

// Récupération des comptes désactivés
$resultat = $mysqli->query(str_replace('XXX','mdp LIKE \'!%\'',$requete));
if ( $n = $resultat->num_rows )  {
  echo "        <tr class=\"categorie\">\n          <th>Comptes désactivés ($n)</th>$iconesmultiples\n        </tr>\n";
  while ( $r = $resultat->fetch_assoc() )
    ligne($r,$matieres,$matieresbloquees[$r['id']] ?? '',$autorisations[$r['autorisation']][0]);
  $resultat->free();
}
?>
      </tbody>
    </table>
  </article>

<?php


// Aide et formulaire d'ajout
// L'id "selmult" de la table ne sert qu'à l'affichage (style.css)
?>
  
  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici de modifier les associations entre utilisateurs et matières.</p>
    <p>Chaque bouton <span class="icon-ok"></span> ou <span class="icon-nok"></span> à l'intersection d'un utilisateur et d'une matière permet de modifier immédiatement en cliquant l'association concernée.</p>
    <p>Attention, cette modification est immédiate&nbsp;: si vous supprimez une association, entre un élève et une matière, les notes qu'il pourrait avoir eues. Ajouter à nouveau cette association (en cliquant à nouveau dans la même case) ne permet pas de récupérer des notes perdues.</p>
    <p>Il est possible de traiter simultanément plusieurs utilisateurs en cochant les cases en bout de ligne et en cliquant sur les boutons d'action qui apparaissent alors sur les lignes d'entêtes. Seuls des comptes de même types peuvent être traités simultanément. Les boutons <span class="icon-cocher"></span> permettent de cocher l'ensemble des comptes d'un type donné.</p>
  </div>

  <div id="form-ajoutprof">
    <h3 class="edition">Ajouter un professeur à la liste des colleurs</h3>
    <form>
      <p>Vous pouvez choisir un des professeurs de la classe pour l'ajouter dans le tableau des colleurs, afin de lui ajouter la qualité de colleur dans une matière autre que celle où il enseigne déjà. Le professeur concerné conservera ses droits de professeur dans sa propre matière mais n'aura que des droits de colleurs dans la matière ajoutée.</p>
      <p>Il suffit de cliquer sur le nom du professeur pour l'ajouter.</p>
      <table id="selmult">
        <tbody>
        </tbody>
      </table>
    </form>
  </div>

<?php
fin(true);
?>
